/* protio.h - protio callback struct definition and function prototypes */

/*
 * Copyright (c) 2007, 2008, 2010
 *      Inferno Nettverk A/S, Norway.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. The above copyright notice, this list of conditions and the following
 *    disclaimer must appear in all copies of the software, derivative works
 *    or modified versions, and any portions thereof, aswell as in all
 *    supporting documentation.
 * 2. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by
 *      Inferno Nettverk A/S, Norway.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Inferno Nettverk A/S requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  info@inet.no
 *  Inferno Nettverk A/S
 *  Oslo Research Park
 *  Gaustadalleen 21
 *  NO-0349 Oslo
 *  Norway
 *
 * any improvements or extensions that they make and grant Inferno Nettverk A/S
 * the rights to redistribute these changes.
 *
 */

/* $Id: protio.h,v 1.14 2010/06/25 22:02:28 karls Exp $ */

/*
 * XXX might want to replace having many functions with one function
 *     and e.g., protioevent argument that specifies the event.
 *     the drawback would be that argument specification would be less
 *     flexible.
 */

/* protocol callbacks; called after completion of respective io operation */
struct protops {
	void (*got_rep)(void *);
	void (*got_repdat)(void *);
	void (*got_req)(struct connection *);
	void (*sslcomp)(void *);
	void (*resolve_done)(void *, struct peerset *);
	void (*resolve_err)(void *);
	void (*conndone)(void *);
	void (*connerr)(void *, int);
	void (*mconndone)(void *, int, struct connection *);
	void (*mconnerr)(void *, int, int);
	void (*got_reqdat)(void *);
	/* no func_writerep; combined with repdat */
	void (*sent_repdat)(void *);
	void (*failedreq)(void *);
	void (*streamstart)(void *);
	void (*streamend)(void *);
	void (*connend)(void *);
	void (*freeuldat)(void *);
	void (*stream_tooslow)(void *);
	void (*stream_stopped)(void *);
	void (*stream_comp)(void *);
	void (*stream_wrotedata)(struct connection *, ssize_t);
	void (*stream_readdata)(struct connection *, ssize_t);
	void (*stream_sentblock)(void *, int32_t);
};

void protio(struct connection *);
void dataio(struct connection *);
void iodone(struct connection *);
